//This applet is manufactured by J. Giesen 4/1998
import java.applet.Applet;
import java.util.Date;
import java.awt.*;

public class DNApplet extends Applet {

	Date dat;
	int year, month, date, day, hours, minutes, seconds;		
	Image bild;	
	String[] dayArray = new String[7];
	String monthArray[] = new String[12];				
	Graphics g;
	Button button;
	public DNLocation time;
	public Choice timeChoice;
	public String timeString;	
	public int locOffset;
	int browserOffset;	
	
	
	public double computeDeclination (int T, int M, int J, double STD) {
	
		double K = Math.PI/180.0;
		long N;
		double X, XX, P, NN;
		double Ekliptik, J2000;
	
		 N = 365 * J + T + 31 * M - 46;		 
		 if (M<3) 
			N = N + (int)((J - 1) / 4);
		else
			 N = N - (int)(0.4 * M + 2.3) + (int)(J / 4.0);
			 
		X = (N - 693960) / 1461.0;
		X = (X - (int)X) * 1440.02509 + (int)X * 0.0307572;
		X = X + STD/24.0 * 0.9856645 + 356.6498973;
		X = X + 1.91233 * Math.sin(0.9999825 * X * K);
		X = (X + Math.sin(1.999965 * X * K) / 50.0 + 282.55462)/360.0;
		X = (X - (int)X) * 360.0;
		
	 	J2000 = (J-2000)/100.0;
	 	Ekliptik = 23.43929111 - (46.8150 + (0.00059 - 0.001813 * J2000) * J2000) * J2000 / 3600.0;
		
		X =  Math.sin(X * K) *  Math.sin(K * Ekliptik);

		return Math.atan(X / Math.sqrt(1.0 - X * X)) / K + 0.00075;	
	}
	
	public double computeGHA (int T, int M, int J, double STD) {
	
		double K = Math.PI/180.0;
		long N;
		double X, XX, P, NN;
		
		 N = 365 * J + T + 31 * M - 46;		 
		 if (M<3) 
			N = N + (int)((J - 1) / 4);
		else
			 N = N - (int)(0.4 * M + 2.3) + (int)(J / 4.0);
			 
		P = STD/24.0;
		X = (P + N - 7.22449E5) * 0.98564734 + 279.306;
		X = X * K;
		XX = -104.55 * Math.sin(X) - 429.266 * Math.cos(X) + 595.63 * Math.sin(2.0 * X) - 2.283 * Math.cos(2.0 * X);
		XX = XX + 4.6 * Math.sin(3.0 * X) + 18.7333 * Math.cos(3.0 * X);
		XX = XX - 13.2 * Math.sin(4.0 * X) - Math.cos(5.0 * X) - Math.sin(5.0 * X) / 3.0 + 0.5 * Math.sin(6.0 * X) + 0.231;
		XX = XX / 240.0 + 360.0 * (P + 0.5);
		if (XX > 360) 
			XX = XX - 360.0;  
 		return XX;				
	}
	
	
	public void myDayMonth() {
		dayArray[0] = "Sunday"; dayArray[1] = "Monday";
		dayArray[2] = "Tuesday"; dayArray[3] = "Wednesday";
		dayArray[4] = "Thursday"; dayArray[5] = "Friday";
		dayArray[6] = "Saturday";
		
		monthArray[0] = "January"; monthArray[1] = "February";
		monthArray[2] = "March"; monthArray[3] = "April";
		monthArray[4] = "May"; monthArray[5] = "June";
		monthArray[6] = "July"; monthArray[7] = "August";
		monthArray[8] = "September"; monthArray[9] = "October";
		monthArray[10] = "November"; monthArray[11] = "December";
	}
	
	
			
	
	public void init ( ) {
	
		String bildname;
		Image picture;
		Rectangle r;
		MediaTracker tracker;	
	
		myDayMonth();		
							
		bildname = getParameter("Bild");
		bild = getImage(getDocumentBase(),bildname);
		
		dat = new Date( );		
		
		r = this.bounds();
		picture = createImage(r.width,r.height);
		g = picture.getGraphics();

		tracker = new MediaTracker(this);
		tracker.addImage(bild,0);
	
		try {tracker.waitForID(0);} catch(Exception e) { };
		
		Panel panel = new Panel();
		add("Buttons", panel);
		add("Choice", panel);
				
		time = new DNLocation();
		timeChoice = new Choice();
		time.timeMenu(timeChoice);
		panel.add(timeChoice);
								
		button = new Button();
		button.setLabel("update time");
		panel.add(button);
		
		dat = new Date( );
		browserOffset = dat.getTimezoneOffset();
		browserOffset = browserOffset/60;
		locOffset = browserOffset;				
		timeString = browserOffset + " h";		
		timeChoice.select(timeString);
		
		resize(size().width,size().height);	
			
	}
	
			
	public int computeLat(int longitude, double dec) {
	
		double K = Math.PI/180.0;
		double tan, itan;
	
		tan = - Math.cos(longitude*K)/Math.tan(dec*K);						
		itan = Math.atan(tan);
		itan = itan/K;
					
		return (int)Math.round(itan);
	}
							
			
	public void paint ( Graphics g ) {
	
		int x0=180, xOben=40, y0=90+xOben, xL=20, left = 370+xL;
		double dec, STD, GHA;
		int Radius = 3;
		int x, y, yy, yy1;
		String s;
		int p;

		g.drawImage(bild,xL,xOben,this);
		g.drawRect(xL,xOben,360,178);
		
		g.drawString("time zone offset : ",xL,xOben-15);
						
		dat = new Date( );
		String str = dat.toString( ); g.drawString(str,xL,245);
		
		day = dat.getDay();
		g.drawString(dayArray[day],left,60);
			
		date = dat.getDate();		
				
		month = dat.getMonth();				
		str = monthArray[month] + " " + str.valueOf(date) + ", ";
				
		year = dat.getYear();
		str = str + " 19" + year;						
		g.drawString(str,left,80);
				
		hours = dat.getHours();

		g.drawString(hours + " Hours",left,100);
		
		minutes = dat.getMinutes();		
		g.drawString(minutes + " Minutes",left,120);
				
		seconds = dat.getSeconds();		
		g.drawString(seconds + " Seconds",left,140);
						
		
		STD = 1.0*(hours+locOffset) + minutes/60.0 + seconds/3600.0;
		dec = computeDeclination(date, month+1, year+1900, STD);
		str = str.valueOf(Math.round(10.0*dec)/10.0);
		s = str.substring(0,str.indexOf(".")+2);											
		g.drawString("Declin. " + s + " deg.",left,160);
		
		GHA = computeGHA(date, month+1, year+1900, STD);
		str = str.valueOf(Math.round(10.0*GHA)/10.0);		
		s = str.substring(0,str.indexOf(".")+2);
		g.drawString("GHA    " + s + " deg.",left,175);			
				
		g.drawString("browser's time zone offset is " + browserOffset + " h",xL,275);
	
		hours = dat.getHours() + locOffset;		
		timeString = locOffset + " h";
		
		if (hours<0)  hours=hours+24;
		if (hours>=24)  hours=hours-24;
		
		if (minutes > 9) str =  ":";
		else str =":0";
		str = hours + str + minutes;	
			
		if (seconds > 9) s = ":";
		else s = ":0";
					
		str = str + s + seconds;
				
		g.setColor(Color.blue);
		g.drawString(str + " GMT",xL,260);
		g.setColor(Color.red);
				
		x = x0 - (int)Math.round(GHA);
		y = y0 - (int)Math.round(dec);		
		if (x > 360) x = x - 360;
		
		g.setColor(Color.yellow);		
		g.fillOval(xL+x-Radius,y-Radius,2*Radius,2*Radius);
		
		g.setColor(Color.red);			
		g.drawOval(xL+x-Radius-1,y-Radius-1,2*Radius+2,2*Radius+2);
		
		g.setColor(Color.gray);
		g.drawLine(xL,y0,xL+2*x0,y0);
		g.drawLine(xL+x0,y0-90,xL+x0,y0+90);
		
		g.setColor(Color.black);
		
		for (int i=-x; x+i<2*x0; i++) {			
			yy = computeLat(i, dec);
			yy1 = computeLat(i+1, dec);			
			g.drawLine(xL+x+i,y0-yy,xL+x+i+1,y0-yy1);			
			if (i % 5 ==0) {
				g.setColor(Color.blue);
				g.drawLine(xL+x+i,y0-yy,xL+x+i,y0+87);
				g.setColor(Color.black);}				
			}						
	}
	
	
	public boolean action(Event event, Object eventobject) {
	
		if (event.target instanceof Button)
			{};
					
		if (event.target==timeChoice) {				
				timeString = timeChoice.getSelectedItem();	
				locOffset = time.getTimeZone(timeString);
				timeChoice.select(timeString);				
			}	
		g.clipRect(0,0,size().width,size().height);	
		repaint(); 													
		return true;
	}				
}

class DNLocation {
					
	
	public void timeMenu(Choice timeChoice) {
		
		timeChoice.addItem("0 h");
		timeChoice.addItem("-1 h");
		timeChoice.addItem("+1 h");
		timeChoice.addItem("-2 h");
		timeChoice.addItem("+2 h");
		timeChoice.addItem("-3 h");
		timeChoice.addItem("+3 h");
		timeChoice.addItem("-4 h");
		timeChoice.addItem("+4 h");
		timeChoice.addItem("-5 h");
		timeChoice.addItem("+5 h");
		timeChoice.addItem("-6 h");
		timeChoice.addItem("+6 h");
		timeChoice.addItem("-7 h");
		timeChoice.addItem("+7 h");
		timeChoice.addItem("-8 h");
		timeChoice.addItem("+8 h");
		timeChoice.addItem("-9 h");
		timeChoice.addItem("+9 h");
		timeChoice.addItem("-10 h");
		timeChoice.addItem("+10 h");
		timeChoice.addItem("-11 h");
		timeChoice.addItem("+11 h");
	}
	
	public int getTimeZone(String timeString) {
	
		int timeOffset = 0;
	
		if (timeString.equals("0 h")) timeOffset = 0;
		else if (timeString.equals("-1 h")) timeOffset = -1;
		else if (timeString.equals("+1 h")) timeOffset = +1;
		else if (timeString.equals("-2 h")) timeOffset = -2;
		else if (timeString.equals("+2 h")) timeOffset = +2;
		else if (timeString.equals("-3 h")) timeOffset = -3;
		else if (timeString.equals("+3 h")) timeOffset = +3;
		else if (timeString.equals("-4 h")) timeOffset = -4;
		else if (timeString.equals("+4 h")) timeOffset = +4;
		else if (timeString.equals("-5 h")) timeOffset = -5;
		else if (timeString.equals("+5 h")) timeOffset = +5;
		else if (timeString.equals("-6 h")) timeOffset = -6;
		else if (timeString.equals("+6 h")) timeOffset = +6;
		else if (timeString.equals("-7 h")) timeOffset = -7;
		else if (timeString.equals("+7 h")) timeOffset = +7;
		else if (timeString.equals("-8 h")) timeOffset = -8;
		else if (timeString.equals("+8 h")) timeOffset = +8;
		else if (timeString.equals("-9 h")) timeOffset = -9;
		else if (timeString.equals("+9 h")) timeOffset = +9;
		else if (timeString.equals("-10 h")) timeOffset = -10;
		else if (timeString.equals("+10 h")) timeOffset = +10;
		else if (timeString.equals("-11 h")) timeOffset = -11;
		else if (timeString.equals("+11 h")) timeOffset = +11;
		
		return timeOffset;
	}				
}
